#Counter DEZ forward
-Taktflanke[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt)
      BEGIN
        IF takt'event and takt='|Taktflanke|'
                THEN IF qi = 9 THEN qi <= "0000";
                               ELSE qi <= qi + 1; END IF;
        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>

#Counter DEZ forward with carry, borrow
-Taktflanke[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt  : in std_logic;
           q     : out std_logic_vector(3 downto 0);
           c_in  : in std_logic;
           c_out : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt)
      BEGIN
        IF takt'event and takt='|Taktflanke|'
           THEN IF c_in = '1' THEN IF qi = 9 THEN qi <= "0000";
                                             ELSE qi <= qi + 1; END IF;
                END IF;
        END IF;
      END PROCESS ct;

  cx: PROCESS(qi)
      BEGIN
        IF qi = 9 THEN c_out <= '1'; ELSE c_out <= '0'; 
        END IF;
      END PROCESS cx;

  q <= qi;
end Behavioral;
>



#Counter DEZ forward with async Reset
-Taktflanke[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           reset : in std_logic;
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
                THEN IF qi = 9 THEN qi <= "0000";
                               ELSE qi <= qi + 1; END IF;
        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>

#Counter DEZ forward with async Reset, carry, borrow
-Taktflanke[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt  : in std_logic;
           reset : in std_logic;
           q     : out std_logic_vector(3 downto 0);
           c_in  : in std_logic;
           c_out : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF c_in = '1' THEN IF qi = 9 THEN qi <= "0000";
                                                ELSE qi <= qi + 1; END IF;
                   END IF;
        END IF;
      END PROCESS ct;

  cx: PROCESS(qi)
      BEGIN
        IF qi = 9 THEN c_out <= '1'; ELSE c_out <= '0'; 
        END IF;
      END PROCESS cx;

  q <= qi;
end Behavioral;
>



#Counter DEZ forward with async Reset, sync Load
-Taktflanke[1,0]
-Reset[1,0]
-Load[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           reset : in std_logic;
           load : in std_logic;
           d : in std_logic_vector(3 downto 0);
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset,load,d)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF load='|Load|' THEN qi <= d;
                                    ELSE IF qi = 9 THEN qi <= "0000";
                                                   ELSE qi <= qi + 1; END IF;
                   END IF;
        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>

#Counter DEZ forward with async Reset, sync Load, carry, borrow
-Taktflanke[1,0]
-Reset[1,0]
-Load[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt  : in std_logic;
           reset : in std_logic;
           load  : in std_logic;
           d     : in std_logic_vector(3 downto 0);
           q     : out std_logic_vector(3 downto 0);
           c_in  : in std_logic;
           c_out : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset,load,d)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF load='|Load|' THEN qi <= d;
                                    ELSIF c_in = '1' THEN IF qi = 9 THEN qi <= "0000";
                                                                    ELSE qi <= qi + 1; END IF;
              END IF;
        END IF;
      END PROCESS ct;

  cx: PROCESS(qi)
      BEGIN
        IF qi = 9 THEN c_out <= '1'; ELSE c_out <= '0'; 
        END IF;
      END PROCESS cx;

  q <= qi;
end Behavioral;
>



#Counter DEZ revers
-Taktflanke[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt)
      BEGIN
        IF takt'event and takt='|Taktflanke|'
                THEN IF qi = 0 THEN qi <= "1001";
                               ELSE qi <= qi - 1; END IF;
        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>


#Counter DEZ revers with async Reset
-Taktflanke[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           reset : in std_logic;
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
                THEN IF qi = 0 THEN qi <= "1001";
                               ELSE qi <= qi - 1; END IF;

        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>

#Counter DEZ revers with async Reset, carry, borrow
-Taktflanke[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt  : in std_logic;
           reset : in std_logic;
           q     : out std_logic_vector(3 downto 0);
           c_in  : in std_logic;
           c_out : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF c_in = '1' THEN IF qi = 0 THEN qi <= "1001";
                                                ELSE qi <= qi - 1; END IF;
              END IF;
        END IF;
      END PROCESS ct;

  cx: PROCESS(qi)
      BEGIN
        IF qi = 0 THEN c_out <= '1'; ELSE c_out <= '0';
        END IF;
      END PROCESS cx;

  q <= qi;
end Behavioral;
>



#Counter DEZ revers with async Reset, sync Load
-Taktflanke[1,0]
-Reset[1,0]
-Load[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           reset : in std_logic;
           load : in std_logic;
           d : in std_logic_vector(3 downto 0);
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset,load,d)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF load='|Load|' THEN qi <= d;
                                    ELSE IF qi = 0 THEN qi <= "1001";
                                                   ELSE qi <= qi - 1; END IF;
                   END IF;
        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>

#Counter DEZ revers with async Reset, sync Load, carry, borrow
-Taktflanke[1,0]
-Reset[1,0]
-Load[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt  : in std_logic;
           reset : in std_logic;
           load  : in std_logic;
           d     : in std_logic_vector(3 downto 0);
           q     : out std_logic_vector(3 downto 0);
           c_in  : in std_logic;
           c_out : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset,load,d)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF load='|Load|' THEN qi <= d;
                                    ELSIF c_in = '1' THEN IF qi = 0 THEN qi <= "1001";
                                                                    ELSE qi <= qi - 1; END IF;
              END IF;
        END IF;
      END PROCESS ct;

  cx: PROCESS(qi)
      BEGIN
        IF qi = 0 THEN c_out <= '1'; ELSE c_out <= '0';
        END IF;
      END PROCESS cx;

  q <= qi;
end Behavioral;
>



#Counter DEZ with Direction
-Taktflanke[1,0]
-Direction{up}[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           dir : in std_logic;
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,dir)
      BEGIN
        IF takt'event and takt='|Taktflanke|' THEN
            IF dir = '|Direction{up}|'
               THEN IF qi = 9 THEN qi <= "0000";
                              ELSE qi <= qi + 1; END IF;
               ELSE IF qi = 0 THEN qi <= "1001";
                              ELSE qi <= qi - 1; END IF;
            END IF;
        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>

#Counter DEZ with Direction, carry, borrow
-Taktflanke[1,0]
-Direction{up}[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt  : in std_logic;
           dir : in std_logic;
           q     : out std_logic_vector(3 downto 0);
           c_in  : in std_logic;
           c_out : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,dir)
      BEGIN
        IF takt'event and takt='|Taktflanke|'
           THEN IF dir = '|Direction{up}|'
                   THEN IF c_in = '1' THEN IF qi = 9 THEN qi <= "0000";
                                                     ELSE qi <= qi + 1; END IF;
                                              END IF;
                   ELSIF c_in = '1' THEN IF qi = 0 THEN qi <= "1001";
                                                   ELSE qi <= qi - 1; END IF;
                END IF;
        END IF;
      END PROCESS ct;

  cx: PROCESS(qi)
      BEGIN
        IF dir = '|Direction{up}|' THEN IF qi = 9 THEN c_out <= '1'; ELSE c_out <= '0'; END IF;
                                   ELSIF qi = 0 THEN c_out <= '1'; ELSE c_out <= '0';
        END IF;
      END PROCESS cx;

  q <= qi;
end Behavioral;
>



#Counter DEZ with async Reset, Direction
-Taktflanke[1,0]
-Direction{up}[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           reset : in std_logic;
           dir : in std_logic;
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset,dir)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|' THEN
                IF dir = '|Direction{up}|'
                   THEN IF qi = 9 THEN qi <= "0000";
                                  ELSE qi <= qi + 1; END IF;
                   ELSE IF qi = 0 THEN qi <= "1001";
                                  ELSE qi <= qi - 1; END IF;
                END IF;
        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>

#Counter DEZ with async Reset, Direction, carry, borrow
-Taktflanke[1,0]
-Direction{up}[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt  : in std_logic;
           reset : in std_logic;
           dir   : in std_logic;
           q     : out std_logic_vector(3 downto 0);
           c_in  : in std_logic;
           c_out : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset,dir)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF dir = '|Direction{up}|'
                      THEN IF c_in = '1' THEN IF qi = 9 THEN qi <= "0000";
                                                        ELSE qi <= qi + 1; END IF;
                                              END IF;
                      ELSIF c_in = '1' THEN IF qi = 0 THEN qi <= "1001";
                                                      ELSE qi <= qi - 1; END IF;
              END IF;
        END IF;
      END PROCESS ct;

  cx: PROCESS(qi)
      BEGIN
        IF dir = '|Direction{up}|' THEN IF qi = 9 THEN c_out <= '1'; ELSE c_out <= '0'; END IF;
                                   ELSIF qi = 0 THEN c_out <= '1'; ELSE c_out <= '0';
        END IF;
      END PROCESS cx;

  q <= qi;
end Behavioral;
>



#Counter DEZ with async Reset, sync Load, Direction
-Taktflanke[1,0]
-Direction{up}[1,0]
-Reset[1,0]
-Load[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt : in std_logic;
           reset: in std_logic;
           load : in std_logic;
           dir : in std_logic;
           d : in std_logic_vector(3 downto 0);
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset,load,d,dir)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF load='|Load|' THEN qi <= d;
                                    ELSE IF dir = '|Direction{up}|'
                                            THEN IF qi = 9 THEN qi <= "0000";
                                                           ELSE qi <= qi + 1; END IF;
                                            ELSE IF qi = 0 THEN qi <= "1001";
                                                           ELSE qi <= qi - 1; END IF;
                                         END IF;
              END IF;
        END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
>

#Counter DEZ with async Reset, sync Load, Direction, carry, borrow
-Taktflanke[1,0]
-Direction{up}[1,0]
-Reset[1,0]
-Load[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( takt  : in std_logic;
           reset : in std_logic;
           load  : in std_logic;
           dir   : in std_logic;
           d     : in std_logic_vector(3 downto 0);
           q     : out std_logic_vector(3 downto 0);
           c_in  : in std_logic;
           c_out : out std_logic);
end |Name|;

architecture Behavioral of |Name| is
signal qi : std_logic_vector(3 downto 0);
begin

  ct: PROCESS (takt,reset,load,d,dir)
      BEGIN
        IF reset='|Reset|' THEN qi <= "0000";
          ELSIF takt'event and takt='|Taktflanke|'
              THEN IF load='|Load|' THEN qi <= d;
                                    ELSE IF dir = '|Direction{up}|'
                                            THEN IF c_in = '1' THEN IF qi = 9 THEN qi <= "0000";
                                                                              ELSE qi <= qi + 1; END IF;
                                                 END IF;
                                            ELSIF c_in = '1' THEN IF qi = 0 THEN qi <= "1001";
                                                                            ELSE qi <= qi - 1;  END IF;
                                         END IF;
              END IF;
        END IF;
      END PROCESS ct;

  cx: PROCESS(qi)
      BEGIN
        IF qi = 9 THEN c_out <= '1'; ELSE c_out <= '0'; END IF;
                                   ELSIF qi = 0 THEN c_out <= '1'; ELSE c_out <= '0';
        END IF;
      END PROCESS cx;

  q <= qi;
end Behavioral;
>
