#BI11
-Bits[1..36]
-Enable[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( Enable : in std_logic;
           IO     : inout std_ulogic_vector(|Bits-| downto 0) BUS;
           Out_I  : in std_logic_vector(|Bits-| downto 0);
           In_O   : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture behavioral of |Name| is
begin
  pWR: PROCESS(Enable,Out_I)
       BEGIN
         IF Enable = '|Enable|' THEN IO <= To_StdULogicVector(Out_I);
                         ELSE IO <= |$Z,Bits|;  
         END IF;
       END PROCESS pWR;

  pRD: PROCESS(IO)
       BEGIN
         In_O <= To_StdLogicVector(IO);
       END PROCESS pRD;

end behavioral;
>


#BI21 with Inverter
-Bits[1..36]
-Enable[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( Enable : in std_logic;
           IO     : inout std_ulogic_vector(|Bits-| downto 0) BUS;
           Out_I  : in std_logic_vector(|Bits-| downto 0);
           In_O   : out std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture behavioral of |Name| is
begin
  pWR: PROCESS(Enable,Out_I)
       BEGIN
         IF Enable = '|Enable|' THEN IO <= To_StdULogicVector(not Out_I);
                         ELSE IO <= |$Z,Bits|; 
         END IF;
       END PROCESS pWR;

  pRD: PROCESS(IO)
       BEGIN
         In_O <= To_StdLogicVector(not IO);
       END PROCESS pRD;

end behavioral;
>


#OT11
-Bits[1..36]
-Enable[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( Enable : in std_logic;
           IO     : inout std_ulogic_vector(|Bits-| downto 0) BUS;
           Out_I  : in std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture behavioral of |Name| is
begin
  pWR: PROCESS(Enable,Out_I)
       BEGIN
         IF Enable = '|Enable|' THEN IO <= To_StdULogicVector(Out_I);
                         ELSE IO <= |$Z,Bits|;  
         END IF;
       END PROCESS pWR;
end behavioral;
>


#OT21 with Inverter
-Bits[1..36]
-Enable[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( Enable : in std_logic;
           IO     : inout std_ulogic_vector(|Bits-| downto 0) BUS;
           Out_I  : in std_logic_vector(|Bits-| downto 0));
end |Name|;

architecture behavioral of |Name| is
begin
  pWR: PROCESS(Enable,Out_I)
       BEGIN
         IF Enable = '|Enable|' THEN IO <= To_StdULogicVector(not Out_I);
                         ELSE IO <= |$Z,Bits|;  
         END IF;
       END PROCESS pWR;
end behavioral;
>

