#BIN_7Segment
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( d : in std_logic_vector(3 downto 0);
           q : out std_logic_vector(6 downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  PROCESS (d)
  BEGIN
    CASE D IS
      WHEN "0000"=>  q <="1111110";
      WHEN "0001"=>  q <="0110000";
      WHEN "0010"=>  q <="1101101";
      WHEN "0011"=>  q <="1111001";
      WHEN "0100"=>  q <="0110011";
      WHEN "0101"=>  q <="1011011";
      WHEN "0110"=>  q <="1011111";
      WHEN "0111"=>  q <="1110000";
      WHEN "1000"=>  q <="1111111";
      WHEN "1001"=>  q <="1111011";
      WHEN "1010"=>  q <="1110111";
      WHEN "1011"=>  q <="0011111";
      WHEN "1100"=>  q <="1001110";
      WHEN "1101"=>  q <="0111101";
      WHEN "1110"=>  q <="1001111";
      WHEN "1111"=>  q <="1000111";
      WHEN OTHERS=>  q <="XXXXXXX";
    END CASE;
  END PROCESS;
end Behavioral;
>


#BIN2DEZ
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( d : in std_logic_vector(8 downto 0);
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  with d select
  q <= "0001" when "000000001",
       "0010" when "000000010",
       "0011" when "000000100",
       "0100" when "000001000",
       "0101" when "000010000",
       "0110" when "000100000",
       "0111" when "001000000",
       "1000" when "010000000",
       "1001" when "100000000",
       "0000" when  Others;
end Behavioral;
>


#BIN2HEX
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity |Name| is
    Port ( d : in std_logic_vector(14 downto 0);
           q : out std_logic_vector(3 downto 0));
end |Name|;

architecture Behavioral of |Name| is
begin
  with d select
  q <= "0001" when "000000000000001",
       "0010" when "000000000000010",
       "0011" when "000000000000100",
       "0100" when "000000000001000",
       "0101" when "000000000010000",
       "0110" when "000000000100000",
       "0111" when "000000001000000",
       "1000" when "000000010000000",
       "1001" when "000000100000000",
       "1010" when "000001000000000",
       "1011" when "000010000000000",
       "1100" when "000100000000000",
       "1101" when "001000000000000",
       "1110" when "010000000000000",
       "1111" when "100000000000000",
       "0000" when  Others;
end Behavioral;
>

